package cipherlab.rfid.demo;

import java.util.List;

import cipherlab.rfid.device1800.config.BluetoothSocketConnector;
import cipherlab.rfid.device1800.config.DeviceResponse;
import cipherlab.rfid.device1800.config.EPCData;
import cipherlab.rfid.device1800.config.IConfigEventListener;
import cipherlab.rfid.device1800.config.InventoryData;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.os.Bundle;

import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.RadioButton;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

public class DevicePickerActivity extends Activity implements OnClickListener {

	private Spinner mSpinner;
	private ImageButton mBtnSetting;
	private Button mBtnConnect;
	private RadioButton mNormal;
	private RadioButton mAuto;
	private List<String> list;
	private ArrayAdapter<String> adapter;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.picker);

		AppHelper.mConnector = new BluetoothSocketConnector(this);
		listener mylistener = new listener();
		AppHelper.mConnector.addListener(mylistener);

		mBtnSetting = (ImageButton) findViewById(R.id.imageButton);
		mBtnSetting.setOnClickListener(this);

		mBtnConnect = (Button) findViewById(R.id.connectButton);
		mBtnConnect.setOnClickListener(this);

		mNormal = (RadioButton) findViewById(R.id.btn_testitem1);	
		mNormal.setChecked(true);
		mAuto = (RadioButton) findViewById(R.id.btn_testitem2);		
	}

	@Override
	protected void onDestroy() {
		AppHelper.ReleaseObject();
		super.onDestroy();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {

		switch (item.getItemId()) {
		case R.id.action_about: {
			View messageView = getLayoutInflater().inflate(R.layout.about,
					null, false);

			TextView AppVer = (TextView) messageView
					.findViewById(R.id.txt_app_ver);
			TextView ServiceVer = (TextView) messageView
					.findViewById(R.id.txt_service_ver);
			PackageManager manager = this.getPackageManager();
			try {
				PackageInfo info = manager.getPackageInfo(
						this.getPackageName(), 0);
				AppVer.setText(info.versionName);

			} catch (NameNotFoundException e) {
				e.printStackTrace();
			}

			ServiceVer.setText("1.0.0");

			AlertDialog.Builder builder = new AlertDialog.Builder(this);
			builder.setIcon(R.drawable.ic_launcher);
			builder.setTitle(R.string.app_name);
			builder.setView(messageView);
			builder.setPositiveButton(R.string.STR_OK,
					new DialogInterface.OnClickListener() {
						@Override
						public void onClick(DialogInterface arg0, int arg1) {

						}// end onClick()
					});
			builder.create();
			builder.show();
			break;
		}
		}
		return true;
	}

	@Override
	protected void onStart() {

		if (AppHelper.mConnector.IsBlueToothTurnOn() == true) {
			list = AppHelper.mConnector.GetPairedDevice();
			if (list != null) {
				adapter = new ArrayAdapter<String>(this,
						R.layout.dropdown_item, list);
				mSpinner = (Spinner) findViewById(R.id.spinner_encoding);
				mSpinner.setAdapter(adapter);
				mBtnConnect.setEnabled(true);
			} else {
				mBtnConnect.setEnabled(false);
			}
		} else {
			mBtnConnect.setEnabled(false);
			String temp = getString(R.string.MSG_BtTurnOnError);
			Toast t = Toast.makeText(DevicePickerActivity.this, temp,
					Toast.LENGTH_SHORT);
			t.show();
		}
		super.onStart();
	}

	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.imageButton: {
			Intent intentBluetooth = new Intent();
			intentBluetooth
					.setAction(android.provider.Settings.ACTION_BLUETOOTH_SETTINGS);
			startActivity(intentBluetooth);
			break;
		}
		case R.id.connectButton: {
			AppHelper.InitialObject();
			AppHelper.mConnector.Device = (String) mSpinner.getSelectedItem();
			boolean result = AppHelper.mConnector.Connect();
			if (result == true) {

			}
			break;
		}
		}
	}

	private void DeviceConnected() {
		if (mNormal.isChecked() == true) {
			Intent intent = new Intent();
			intent.setClass(DevicePickerActivity.this, MainActivity.class);
			startActivity(intent);
		} else {
			Intent intent = new Intent();
			intent.setClass(DevicePickerActivity.this, AutoTestActivity.class);
			startActivity(intent);
		}
	}

	public class listener implements IConfigEventListener {
		public void onConnected() {
			AppHelper.GetHandle();
			DeviceConnected();
		}

		public void onDisconnected() {

		}

		public void onDeviceEvent(int value) {

		}

		@Override
		public void onDataTransmission(EPCData data) {

		}

		@Override
		public void onInventory(InventoryData data, DeviceResponse response) {

		}

		@Override
		public void onReadTag(byte[] data, DeviceResponse response) {

		}
	}

}
